Package org.springframework.orm.jpa.support

# Class OpenEntityManagerInViewFilter

java.lang.Object
org.springframework.web.filter.GenericFilterBean
org.springframework.web.filter.OncePerRequestFilter
org.springframework.orm.jpa.support.OpenEntityManagerInViewFilter

All Implemented Interfaces:
  `Filter`, `org.springframework.beans.factory.Aware`, `org.springframework.beans.factory.BeanNameAware`, `org.springframework.beans.factory.DisposableBean`, `org.springframework.beans.factory.InitializingBean`, `org.springframework.context.EnvironmentAware`, `org.springframework.core.env.EnvironmentCapable`, `org.springframework.web.context.ServletContextAware`

public class OpenEntityManagerInViewFilter extends org.springframework.web.filter.OncePerRequestFilter
Servlet Filter that binds a JPA EntityManager to the thread for the entire processing of the request. Intended for the "Open EntityManager in View" pattern, i.e. to allow for lazy loading in web views despite the original transactions already being completed.

This filter makes JPA EntityManagers available via the current thread, which will be autodetected by transaction managers. It is suitable for service layer transactions via `JpaTransactionManager` or `JtaTransactionManager` as well as for non-transactional read-only execution.

Looks up the EntityManagerFactory in Spring's root web application context. Supports an "entityManagerFactoryBeanName" filter init-param in `web.xml`; the default bean name is "entityManagerFactory". As an alternative, the "persistenceUnitName" init-param allows for retrieval by logical unit name (as specified in `persistence.xml`).

Since:
  2.0
Author:
  Juergen Hoeller
See Also:
  - `OpenEntityManagerInViewInterceptor`
  - `JpaTransactionManager`
  - `SharedEntityManagerCreator`
  - `TransactionSynchronizationManager`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`DEFAULT_ENTITY_MANAGER_FACTORY_BEAN_NAME`
Default EntityManagerFactory bean name: "entityManagerFactory".

### Fields inherited from class org.springframework.web.filter.OncePerRequestFilter

`ALREADY_FILTERED_SUFFIX`

### Fields inherited from class org.springframework.web.filter.GenericFilterBean

`logger`

## Constructor Summary

Constructors
Constructor
Description
`OpenEntityManagerInViewFilter()`

## Method Summary

Modifier and Type
Method
Description
`protected EntityManager`
`createEntityManager(EntityManagerFactory emf)`
Create a JPA EntityManager to be bound to a request.
`protected void`
`doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain)`
`protected String`
`getEntityManagerFactoryBeanName()`
Return the bean name of the EntityManagerFactory to fetch from Spring's root application context.
`protected String`
`getPersistenceUnitName()`
Return the name of the persistence unit to access the EntityManagerFactory for, if any.
`protected EntityManagerFactory`
`lookupEntityManagerFactory()`
Look up the EntityManagerFactory that this filter should use.
`protected EntityManagerFactory`
`lookupEntityManagerFactory(HttpServletRequest request)`
Look up the EntityManagerFactory that this filter should use, taking the current HTTP request as argument.
`void`
`setEntityManagerFactoryBeanName(String entityManagerFactoryBeanName)`
Set the bean name of the EntityManagerFactory to fetch from Spring's root application context.
`void`
`setPersistenceUnitName(String persistenceUnitName)`
Set the name of the persistence unit to access the EntityManagerFactory for.
`protected boolean`
`shouldNotFilterAsyncDispatch()`
Returns "false" so that the filter may re-bind the opened `EntityManager` to each asynchronously dispatched thread and postpone closing it until the very last asynchronous dispatch.
`protected boolean`
`shouldNotFilterErrorDispatch()`
Returns "false" so that the filter may provide an `EntityManager` to each error dispatches.

### Methods inherited from class org.springframework.web.filter.OncePerRequestFilter

`doFilter, doFilterNestedErrorDispatch, getAlreadyFilteredAttributeName, isAsyncDispatch, isAsyncStarted, shouldNotFilter`

### Methods inherited from class org.springframework.web.filter.GenericFilterBean

`addRequiredProperty, afterPropertiesSet, createEnvironment, destroy, getEnvironment, getFilterConfig, getFilterName, getServletContext, init, initBeanWrapper, initFilterBean, setBeanName, setEnvironment, setServletContext`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### DEFAULT_ENTITY_MANAGER_FACTORY_BEAN_NAME

public static final String DEFAULT_ENTITY_MANAGER_FACTORY_BEAN_NAME
Default EntityManagerFactory bean name: "entityManagerFactory". Only applies when no "persistenceUnitName" param has been specified.

See Also:
  - `setEntityManagerFactoryBeanName(java.lang.String)`
  - `setPersistenceUnitName(java.lang.String)`
  - Constant Field Values

## Constructor Details

### OpenEntityManagerInViewFilter

public OpenEntityManagerInViewFilter()

## Method Details

### setEntityManagerFactoryBeanName

public void setEntityManagerFactoryBeanName(@Nullable String entityManagerFactoryBeanName)
Set the bean name of the EntityManagerFactory to fetch from Spring's root application context.

Default is "entityManagerFactory". Note that this default only applies when no "persistenceUnitName" param has been specified.

See Also:
  - `setPersistenceUnitName(java.lang.String)`
  - `DEFAULT_ENTITY_MANAGER_FACTORY_BEAN_NAME`

### getEntityManagerFactoryBeanName

@Nullable protected String getEntityManagerFactoryBeanName()
Return the bean name of the EntityManagerFactory to fetch from Spring's root application context.

### setPersistenceUnitName

public void setPersistenceUnitName(@Nullable String persistenceUnitName)
Set the name of the persistence unit to access the EntityManagerFactory for.

This is an alternative to specifying the EntityManagerFactory by bean name, resolving it by its persistence unit name instead. If no bean name and no persistence unit name have been specified, we'll check whether a bean exists for the default bean name "entityManagerFactory"; if not, a default EntityManagerFactory will be retrieved through finding a single unique bean of type EntityManagerFactory.

See Also:
  - `setEntityManagerFactoryBeanName(java.lang.String)`
  - `DEFAULT_ENTITY_MANAGER_FACTORY_BEAN_NAME`

### getPersistenceUnitName

@Nullable protected String getPersistenceUnitName()
Return the name of the persistence unit to access the EntityManagerFactory for, if any.

### shouldNotFilterAsyncDispatch

protected boolean shouldNotFilterAsyncDispatch()
Returns "false" so that the filter may re-bind the opened `EntityManager` to each asynchronously dispatched thread and postpone closing it until the very last asynchronous dispatch.

Overrides:
  `shouldNotFilterAsyncDispatch` in class `org.springframework.web.filter.OncePerRequestFilter`

### shouldNotFilterErrorDispatch

protected boolean shouldNotFilterErrorDispatch()
Returns "false" so that the filter may provide an `EntityManager` to each error dispatches.

Overrides:
  `shouldNotFilterErrorDispatch` in class `org.springframework.web.filter.OncePerRequestFilter`

### doFilterInternal

protected void doFilterInternal(HttpServletRequest request, HttpServletResponse response, FilterChain filterChain) throws ServletException, IOException

Specified by:
  `doFilterInternal` in class `org.springframework.web.filter.OncePerRequestFilter`
Throws:
  `ServletException`
  `IOException`

### lookupEntityManagerFactory

protected EntityManagerFactory lookupEntityManagerFactory(HttpServletRequest request)
Look up the EntityManagerFactory that this filter should use, taking the current HTTP request as argument.

The default implementation delegates to the `lookupEntityManagerFactory` without arguments, caching the EntityManagerFactory reference once obtained.

Returns:
  the EntityManagerFactory to use
See Also:
  - `lookupEntityManagerFactory()`

### lookupEntityManagerFactory

protected EntityManagerFactory lookupEntityManagerFactory()
Look up the EntityManagerFactory that this filter should use.

The default implementation looks for a bean with the specified name in Spring's root application context.

Returns:
  the EntityManagerFactory to use
See Also:
  - `getEntityManagerFactoryBeanName()`

### createEntityManager

protected EntityManager createEntityManager(EntityManagerFactory emf)
Create a JPA EntityManager to be bound to a request.

Can be overridden in subclasses.

Parameters:
  `emf` - the EntityManagerFactory to use
See Also:
  - `EntityManagerFactory.createEntityManager()`